
import pygame
import math
from pygame.locals import *

from OpenGL.GL import *

from cTexture import Texture

class Font:
	LEFT = 0
	RIGHT = 1
	CENTER = 2
	
	def __init__(self, font, charsize = 32):
		self.texture = Texture.load(font)
		self.charsize = charsize

	def drawtext(self, text, x, y, align = LEFT):
		b = 1.5 / self.texture.size[0] # the first value is the border size in pixels
		cs = 1 / 16.0
		
		self.texture.setup()
		size = self.charsize

		dx = 24 # char width
		
		textLen = len(text);

		if self.CENTER == align:
			sx = x - textLen * dx / 2.0
		elif self.RIGHT == align:
			sx = x - textLen * dx
		else:
			sx = x
		
		glBegin(GL_QUADS)

		for k in range(textLen):
			char = ord(text[k])
			u = cs * (char % 16) + b
			v = cs * (char / 16) + b
			kdx = k * dx
			glTexCoord(u     , v + cs); glVertex2f(sx + kdx       , y)
			glTexCoord(u     , v     ); glVertex2f(sx + kdx       , y + size)
			glTexCoord(u + cs, v     ); glVertex2f(sx + kdx + size, y + size)
			glTexCoord(u + cs, v + cs); glVertex2f(sx + kdx + size, y)

		glEnd()
			
	def drawtextcenter(self, text, x, y):
		self.drawtext(text, x, y, self.CENTER)

	def drawtextright(self, text, x, y):
		self.drawtext(text, x, y, self.RIGHT)
