import math

from OpenGL.GL import *

from cTimer import Timer

from cBaseCharacter import BaseCharacter

class Hero(BaseCharacter):
	texturepath='graphics/hero.png'

	yspeed=0
	xspeed=0
	maxgrav=0
	gravconst=0.2
	lev_w=5
	lev_h=5

	liquid=1.0

	climb=0

	climbstep=0

	cpos=[0,0,1]
	
	
	#stretch=1.0

	#def __init__(self):
		



	def update(self,level):
		
		dxspeed=dyspeed= 5 * Timer.diff


		lev_w = self.lev_w
		lev_h = self.lev_h


		if(self.climb==0):self.yspeed+=self.gravconst

		if(self.climb==0):self.move((0,-self.yspeed * Timer.diff))

		if(self.climb==0):
			if( self.collidetile(level.tmap,self.pos)):
				pass
			

		self.liquid-=0.02*Timer.diff
		if(self.liquid<0.0):self.liquid=0.0

		self.climby()

	def setxspeed(self,val):
		self.xspeed=val

	def draw(self):
		self.tex.setup()

		d = 1.0/64.0

		o=self.mirrored
		
		glPushMatrix()
		
		glTranslatef( self.pos[0], self.pos[1], 0)
		glScalef( 1+(0.5-self.stretch/2),self.stretch, 1)
		glColor4f(0,1,0,0.8)
		glBegin(GL_QUADS)
		glTexCoord((0+d),(0+d)/2); glVertex2f(-.5*o+self.lean,1)
		glTexCoord((0.5-d),(0+d)/2); glVertex2f( .5*o+self.lean,1)
		glTexCoord((0.5-d),(1-d)/2); glVertex2f( .5*o,0)
		glTexCoord((0+d),(1-d)/2); glVertex2f(-.5*o,0)
		glEnd()

		glColor4f(1,1,1,1)
		glBegin(GL_QUADS)
		glTexCoord((0+d)+0.5,(0+d)/2); glVertex3f(-.5*o+self.lean,1,d)
		glTexCoord((1-d),(0+d)/2); glVertex3f( .5*o+self.lean,1,d)
		glTexCoord((1-d),(1-d)/2); glVertex3f( .5*o,0,d)
		glTexCoord((0+d)+0.5,(1-d)/2); glVertex3f(-.5*o,0,d)
		glEnd()

		glPopMatrix()

		

	def tileval(self,val):

		if val.solid==1: return True
		
		
		return False
			

	def startclimb(self,val):

		if(self.climb==0):
			self.climb=val
			self.cpos[0]=self.pos[0]
			self.cpos[1]=self.pos[1]
			self.cpos[2]=self.stretch
			

	def climby(self):
		
		if(self.climb==0): return

		self.climbstep+=self.climb*Timer.diff

		self.stretch=self.cpos[2]-0.7*abs(self.climbstep)
	
		self.pos[0]=self.cpos[0]+self.climbstep

		self.pos[1]=self.cpos[1]+abs(self.climbstep)

		if(abs(self.climbstep)>=1):
			self.pos[0]=self.cpos[0]
			self.pos[1]=self.cpos[1]
			self.move((self.climb,1))
			self.stretch=self.cpos[2]-0.7
			self.climb=0
			self.climbstep=0


	def collidetile(self, tilemap, pos):

		lev_w = self.lev_w
		lev_h = self.lev_h

		d=1.0/5.0 #how close must be to wall to climb
	
		retval=[0,0]

		if(pos[0]+self.w/2>(lev_w-1)+0.5):
			self.pos[0]=(lev_w-1)-self.w/2+0.5
			retval[0]=True
		if(pos[1]>(lev_h-1)+0.5):
			self.pos[1]=(lev_h-1)-0.5
			retval[1]=True
		if(pos[0]-self.w/2<-0.5):
			self.pos[0]=self.w/2-0.5
			retval[0]=True
		if(pos[1]<-0.5):
			self.pos[1]=-0.5
			self.yspeed=0
			retval[1]=True
	
		yval=math.floor(pos[1]+self.h/2+0.5)
		yval2=math.floor(pos[1]+self.h/2+1/self.h)
		if(self.h<1.0):yval2=math.floor(pos[1]+self.h/2+self.h)
		rcol=math.floor(pos[0]+self.w/2+0.5)
		lcol=math.floor(pos[0]-self.w/2+0.5)

		rcol2=math.floor(pos[0]+self.w/2+0.5+d)
		lcol2=math.floor(pos[0]-self.w/2+0.5-d)

		rcol3=math.floor(pos[0]+self.w/2+0.5-d)
		lcol3=math.floor(pos[0]-self.w/2+0.5+d)
	
		if not retval[0]:

			if(self.stretch>1.4 and (self.lean <-0.7 or self.lean > 0.7) ):
				if(self.tileval(tilemap[int(yval*5+rcol2)]) and self.lean>0.7 and not self.tileval(tilemap[int(yval*5+rcol)]) ): 
					if not self.tileval(tilemap[int(yval*5+rcol2)+5]):
						self.startclimb(1)
						return
				if(self.tileval(tilemap[int(math.floor(yval*5+lcol2))]) and self.lean<-0.7 and not self.tileval(tilemap[int(yval*5+lcol)]) ): 
					if not self.tileval(tilemap[int(yval*5+lcol2)+5]):
						self.startclimb(-1)
						return

			if(self.tileval(tilemap[int(yval*5+lcol)]) and not self.tileval(tilemap[int(yval*5+rcol)]) ): #
				self.pos[0]=lcol+1
				retval[0]=True
			if(self.tileval(tilemap[int(yval*5+rcol)]) and not self.tileval(tilemap[int(yval*5+lcol)]) ): #
				self.pos[0]=rcol-1
				retval[0]=True

			
		if not retval[1]:
			if(self.tileval(tilemap[int((yval2)*5+lcol3-5)]) or self.tileval(tilemap[int((yval2)*5+rcol3-5)]) ):
				self.pos[1]=yval-0.5
				retval[1]=True
				self.yspeed=0

	
		return retval

		xval=int(math.floor(self.pos[0]+pos[0])/2)
		yval=int(math.floor(self.pos[1]+pos[1])/2)
		if(xval>=0 and xval<5 and yval>=0 and yval<5):
			if tilemap[int(xval)+int(yval)*5]==1:
				return True
			print [xval,yval]
		return False
