
import pygame
from pygame.locals import *

import math

from cFont import Font
from cTexture import Texture
from cInput import Input

from OpenGL.GL import *

class MenuSubset:
	def __init__(self):
		self.drawlist=[]
		self.kind = 0

class Menu(Font):
	def __init__(self):
		font='graphics/font.tga'
		
		self.bartex = Texture.load('graphics/bar3.png')
		self.movtex = Texture.load('graphics/flage.png')
		
		self.rot=0
		
		Font.__init__(self,font)
		self.size = 32
		
		self.drawlist = []
		
		mainmenu = MenuSubset()
		optionsmenu = MenuSubset()
		controlsmenu = MenuSubset()
		graphicsmenu = MenuSubset()
		soundmenu = MenuSubset()
		keymenu = MenuSubset()
		joymenu = MenuSubset()
		
		#										Ah, Menus. There are different types. 0 = normal. 1 = slider. 2 = values. 
		#																			3 = key mappings. 4 = joy mappings.
		
		
		mainmenu.drawlist.append(["resume",0])
		mainmenu.drawlist.append(["restart",0])
		mainmenu.drawlist.append(["options",0])
		mainmenu.drawlist.append(["quit",0])
		
		optionsmenu.drawlist.append(["controls",0])
		optionsmenu.drawlist.append(["graphics",0])
		optionsmenu.drawlist.append(["sound",0])
		optionsmenu.drawlist.append(["back",0])
		
		controlsmenu.drawlist.append(["keyboard",0])
		controlsmenu.drawlist.append(["joystick",0])
		controlsmenu.drawlist.append(["back",0])
		
		graphicsmenu.drawlist.append(["resolution",2,0,"640x480","800x600"])
		graphicsmenu.drawlist.append(["fullscreen",2,0,"true","false"])
		graphicsmenu.drawlist.append(["antialiasing",1,0.5])
		graphicsmenu.drawlist.append(["back",0])
		
		soundmenu.drawlist.append(["music level",1,0.25])
		soundmenu.drawlist.append(["sound level",1,0.75])
		soundmenu.drawlist.append(["back",0])
		
		keymenu.drawlist.append(["up",3,0])
		keymenu.drawlist.append(["down",3,1])
		keymenu.drawlist.append(["left",3,2])
		keymenu.drawlist.append(["right",3,3])
		keymenu.drawlist.append(["action",3,4])
		keymenu.drawlist.append(["special",3,5])
		keymenu.drawlist.append(["back",0])
		
		joymenu.drawlist.append(["use joystick",2,0,"false","true","n/a"])
		joymenu.drawlist.append(["up",4,"axis"])
		joymenu.drawlist.append(["down",4,"axis"])
		joymenu.drawlist.append(["left",4,"axis"])
		joymenu.drawlist.append(["right",4,"axis"])
		joymenu.drawlist.append(["action",4,"button"])
		joymenu.drawlist.append(["special",4,"button"])
		joymenu.drawlist.append(["back",0])
		
		
		
		self.drawlist.append(mainmenu)
		self.drawlist.append(optionsmenu)
		self.drawlist.append(controlsmenu)
		self.drawlist.append(graphicsmenu)
		self.drawlist.append(soundmenu)
		self.drawlist.append(keymenu)
		self.drawlist.append(joymenu)
		#self.drawlist.append(mainmenu)
		
		self.active = 0

		self.usejoy = True

		
		#self.indices = []
		
		#self.indices=[0,4,4,8,8,11,11,14,14,17]		#main menu are menu indices 0 through 3 (4 big)

		self.submenu=0
			
	@classmethod		
	def handleMenu2(self,app,val,mkey):
	

		#For changing sliders left/right
	
		if mkey == K_RIGHT:
			if val == (3,2): app.settings.aalevel+=0.25
			if val == (4,0): app.settings.musiclevel+=0.25
			if val == (4,1): app.settings.soundlevel+=0.25

		if mkey == K_LEFT:
			if val == (3,2): app.settings.aalevel-=0.25
			if val == (4,0): app.settings.musiclevel-=0.25
			if val == (4,1): app.settings.soundlevel-=0.25

		#For settings that you can change in-menu, like sound level, make sure they are set

		if app.settings.aalevel>1:app.settings.aalevel=1
		if app.settings.aalevel<0:app.settings.aalevel=0
		
		if app.settings.musiclevel>1:app.settings.musiclevel=1
		if app.settings.musiclevel<0:app.settings.musiclevel=0
		
		if app.settings.soundlevel>1:app.settings.soundlevel=1
		if app.settings.soundlevel<0:app.settings.soundlevel=0
		
		app.menu.drawlist[3].drawlist[2][2]=app.settings.aalevel
		
		app.menu.drawlist[4].drawlist[0][2]=app.settings.musiclevel
		app.menu.drawlist[4].drawlist[1][2]=app.settings.soundlevel
		
		#Key-checking code	
	
		if mkey == K_SPACE or mkey == K_RETURN:
			if val == (0,0):
				app.isatmenu=False
				app.drawlist.remove(app.menu)
				app.game.start(app.settings.usejoy)
			if val == (0,1):
				app.isatmenu=False
				app.drawlist.remove(app.menu)
				app.game.restart()
				
			if val == (0,2):app.menu.setsubmenu(1)
			if val == (0,3):app.running=False
			
			if val == (1,0):app.menu.setsubmenu(2)
			if val == (1,1):app.menu.setsubmenu(3)
			if val == (1,2):app.menu.setsubmenu(4)
			if val == (1,3):app.menu.setsubmenu(0)
				
			if val == (2,0):app.menu.setsubmenu(5)
			if val == (2,1) and not app.joystick.numjoy == 0:app.menu.setsubmenu(6)
			if val == (2,2):app.menu.setsubmenu(1)
			
			if val == (3,0): app.settings.resolution+=1
			if val == (3,1): app.settings.fullscreen+=1
			if val == (3,3):app.menu.setsubmenu(1)
				
			if val == (4,2):app.menu.setsubmenu(1)
				
			
				
			if val == (6,0):
				if not app.joystick.numjoy == 0:
					app.settings.usejoy=1-app.settings.usejoy
				else:
					app.settings.usejoy=1
			
			if val == (5,0):app.menumap=[1,0]		#these blocks of code (this and the one below) could easily be replaced
			if val == (5,1):app.menumap=[1,1]		#with for loops, but i prefer it this way
			if val == (5,2):app.menumap=[1,2]
			if val == (5,3):app.menumap=[1,3]
			if val == (5,4):app.menumap=[1,4]
			if val == (5,5):app.menumap=[1,5]
			if val == (5,6):app.menu.setsubmenu(2)
			
			if val == (6,1):app.menumap=[2,0]		#check the comment some lines up
			if val == (6,2):app.menumap=[2,1]
			if val == (6,3):app.menumap=[2,2]
			if val == (6,4):app.menumap=[2,3]
			if val == (6,5):app.menumap=[2,4]
			if val == (6,6):app.menumap=[2,5]
			if val == (6,7):app.menu.setsubmenu(2)
				
			
		if(app.settings.fullscreen>1):app.settings.fullscreen=0			#stuff might be in an odd order. Some things need to be.
		if(app.settings.resolution>1):app.settings.resolution=0
		
		app.menu.drawlist[6].drawlist[0][2]=app.settings.usejoy
		
		app.menu.drawlist[3].drawlist[1][2]=app.settings.fullscreen
		app.menu.drawlist[3].drawlist[0][2]=app.settings.resolution
	
		if(app.joystick.numjoy==0):
			app.menu.usejoy=False
		else:
			app.menu.usejoy=True
		
		mjoy=app.settings.joy	#entering long names can be annoying...
		akey=app.settings.keys
		
		if not app.menumap[0] == 0:
			if app.menumap[0] == 1: #keyboard mapping
				app.menu.drawlist[5].drawlist[app.menumap[1]][2]="(push)"
			if app.menumap[0] == 2: #joystick mapping
				app.menu.drawlist[6].drawlist[app.menumap[1]+1][2]="(push)"
		
		if app.menumap[0]==0:
			app.menu.drawlist[6].drawlist[1][2]=Input.joystr(mjoy.up)
			app.menu.drawlist[6].drawlist[2][2]=Input.joystr(mjoy.down)
			app.menu.drawlist[6].drawlist[3][2]=Input.joystr(mjoy.left)
			app.menu.drawlist[6].drawlist[4][2]=Input.joystr(mjoy.right)
			app.menu.drawlist[6].drawlist[5][2]=Input.joystr(mjoy.action)
			app.menu.drawlist[6].drawlist[6][2]=Input.joystr(mjoy.special)
		
		if app.menumap[0]==0:
			app.menu.drawlist[5].drawlist[0][2]=Input.keystr(akey.up)
			app.menu.drawlist[5].drawlist[1][2]=Input.keystr(akey.down)
			app.menu.drawlist[5].drawlist[2][2]=Input.keystr(akey.left)
			app.menu.drawlist[5].drawlist[3][2]=Input.keystr(akey.right)
			app.menu.drawlist[5].drawlist[4][2]=Input.keystr(akey.action)
			app.menu.drawlist[5].drawlist[5][2]=Input.keystr(akey.special)
		
		
	def drawrect(self,dx,dy):	#drawing the thing (quad) showing next to the active field in the menu
							
								#haven't had much time to try the rotation. Remove it if it is buggy or whatever
	
			size=32
			nixo=16
			glDisable(GL_TEXTURE_2D)
			glPushMatrix()
			glTranslatef(dx+nixo,dy+nixo,0)
			glRotatef(self.rot,0,0,1)
			
			
			
			glBegin(GL_QUADS)
			glColor3f(0,0.8,0)
			
			glVertex2f(-nixo,	-nixo)
			glVertex2f(-nixo,	nixo)
			glVertex2f(nixo,	nixo)
			glVertex2f(nixo,	-nixo)
			glEnd()
			
			
			glPopMatrix()
			glEnable(GL_TEXTURE_2D)
			self.rot+=0.5
			
	def drawbar(self,x,y):		#drawing a slider / bar using a texture
	
			xsize=200
			ysize=24
			glDisable(GL_TEXTURE_2D)
			glEnable(GL_TEXTURE_2D)
			glBegin(GL_QUADS)
			glColor3f(1,1,1)
			glTexCoord(0   ,0);glVertex2f(x,y)
			glTexCoord(0   ,1);glVertex2f(x,y+ysize)
			glTexCoord(1   ,1);glVertex2f(x+xsize,y+ysize)
			glTexCoord(1   ,0);glVertex2f(x+xsize,y)
			glEnd()
			glEnable(GL_TEXTURE_2D)
			
	def drawmover(self,x,y,percent):	#drawing the thing that can move in sliders
	
			xsize=12
			ysize=24
			glDisable(GL_TEXTURE_2D)
			glEnable(GL_TEXTURE_2D)
			glBegin(GL_QUADS)
			glColor3f(1,1,1)
			glTexCoord(0   ,0);glVertex2f(x-xsize/2+percent*200,y)
			glTexCoord(0   ,1);glVertex2f(x-xsize/2+percent*200,y+ysize)
			glTexCoord(1   ,1);glVertex2f(x+xsize/2+percent*200,y+ysize)
			glTexCoord(1   ,0);glVertex2f(x+xsize/2+percent*200,y)
			glEnd()
			glEnable(GL_TEXTURE_2D)
		
	def draw(self):				#drawing!
		glDisable(GL_DEPTH_TEST)

		glMatrixMode(GL_PROJECTION)
		glLoadIdentity()
		glOrtho(0,640,0,480,0,1)
		glMatrixMode(GL_MODELVIEW)
		glLoadIdentity()
		glEnable(GL_BLEND)

		glDisable(GL_TEXTURE_2D)
		glColor4f(0,0,0,.3)
		glRecti(0,0,640,480)

	
		sbm=self.submenu
		temp=len(self.drawlist[sbm].drawlist)
		j=0
		for i in self.drawlist[sbm].drawlist:
			j+=1
			if(i[1] == 0):	#if the field is a normal text
				
				glColor3f(1,0,0)
				if(sbm==2 and j==2 and self.usejoy==False):# and i[0]=="joystick"):
					glColor4f(0.7,0.7,0.7,0.7)
				Font.drawtextcenter(self,i[0],320,480-32-float(j)*480/float(temp+2))
				glColor4f(1,0,0,1)
				if self.active == j-1:
					self.drawrect(320-len(i[0])*20,480-32-float(j)*480/float(temp+2))
					
			elif(i[1] == 1):	#if the field is a slider
				glColor3f(1,0,0)
				Font.drawtextcenter(self,i[0],320-100,480-32-float(j)*480/float(temp+2))
				if self.active == j-1:
					self.drawrect(320-len(i[0])*20-50,480-32-float(j)*480/float(temp+2))
					
				
				
				barx=320+len(i[0])*10-50
				bary=480-32-float(j)*480/float(temp+2)
				
				self.bartex.setup()
				self.drawbar(barx,bary)
				
				self.movtex.setup()
				self.drawmover(barx,bary,i[2])
				
			elif(i[1] == 2):	#if the field can have different values
				glColor3f(1,0,0)
				Font.drawtext(self,i[0],100,480-32-float(j)*480/float(temp+2))
				if self.active == j-1:
					self.drawrect(20,480-32-float(j)*480/float(temp+2))

				glColor3f(0,0,1)
				Font.drawtextright(self,i[int(i[2]+3)],580,480-32-float(j)*480/float(temp+2))
				
			elif(i[1] == 3):	#if the field is a keyboard key
				glColor3f(1,0,0)
				Font.drawtext(self,i[0],100,480-32-float(j)*480/float(temp+2))
				if self.active == j-1:
					self.drawrect(20,480-32-float(j)*480/float(temp+2))
				glColor3f(0,0,1)
				Font.drawtextright(self,i[2],580,480-32-float(j)*480/float(temp+2))
					
			elif(i[1] == 4):	#if the field is a joystick axis/button
				glColor3f(1,0,0)
				Font.drawtext(self,i[0],100,480-32-float(j)*480/float(temp+2))
				if self.active == j-1:
					self.drawrect(20,480-32-float(j)*480/float(temp+2))
				glColor3f(0,0,1)
				Font.drawtextright(self,i[2],580,480-32-float(j)*480/float(temp+2))
				
				
				
	def changemenu(self,val):		#change the active field = navigate through submenus
		sbm=self.submenu
		self.active+=val
		if self.active < 0: self.active = len(self.drawlist[sbm].drawlist)-1
		if self.active >= len(self.drawlist[sbm].drawlist): self.active=0

	def setsubmenu(self, val):		#enter a different submenu
		self.submenu=val
		self.active=0
		
