
import pygame


from OpenGL.GL import *
from OpenGL.GL.ARB.texture_compression import *

class Texture:
	textures = {}

	@classmethod
	def load(self,file):
		if self.textures.has_key(file):
			return self.textures[file]
		return Texture(file)

	def __init__(self,file):
		self.textures[file] = self
		img = pygame.image.load(file)
		self.size = img.get_size()
		w,h = self.size
		imgdata = pygame.image.tostring(img,'RGBA')
		
		self.texID = glGenTextures(1)
		
		glBindTexture(GL_TEXTURE_2D,self.texID)	
		glTexImage2D( GL_TEXTURE_2D, 0, GL_COMPRESSED_RGBA_ARB, w,h, 0,\
				GL_RGBA, GL_UNSIGNED_BYTE, imgdata)


	def setup(self):
		glEnable(GL_TEXTURE_2D)
		glEnable(GL_BLEND)
		glBindTexture(GL_TEXTURE_2D,self.texID)
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,\
				GL_LINEAR)
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,\
				GL_LINEAR)

