
import pygame

class Timer:
	currentTime = None	
	timers = set()
	diff = 0.0
#	timeDiff = 0

	@classmethod
	def update(self):
		now = pygame.time.get_ticks()

		if self.currentTime == None:
			self.currentTime = now

		self.lastTime = self.currentTime
		self.currentTime = now
		timeDiff = self.currentTime - self.lastTime
		#self.timeDiff = timeDiff
		self.diff = timeDiff/1000.0

		for t in self.timers:
			if t.active:
				t.time += timeDiff

	def __init__(self,active=False):
		self.active = active
		self.time = 0
		if active:
			self.start()

	def start(self):
		self.timers.add(self)
		self.active = True
	
	def stop(self):
		if self.active:
			self.timers.remove(self)
			self.active = False
	
	def reset(self):
		self.stop()
		self.time = 0

	
